{$I DebuggerAnAus.pas}
unit Unit2h;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls;

type
  TForm2 = class(TForm)
    StringGrid1: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure StringGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
                                     Rect: TRect; State: TGridDrawState);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

 const HTMLZeichen =
                      '_ _ Zeile umbrechen und Leerstelle'#13+
                      'h <br> Neue Zeile. Einfach: h h tippen (am ftesten gebraucht)'#13+
                      's &nbsp; space=zustzliche Leerstelle'#13+

                      '_ _ Listen definieren (Tablle siehe Men "Bausteine")'#13+
                      '0 <ul></ul> (Null) Liste definieren'#13+
                      '9 <ol_type="1"></ol> (Neun) Nummerierte Liste definieren'#13+
                      '8 <dd></dd> (Acht) Definitionsliste definieren'#13+
                      'l <li></li> (klein l) Listenelement'#13+
                      'd <dd></dd> Definitionslistenelement'#13+

                      '_ _ Schrgschrift Fettschrift Unterstreichen hoch- und tiefgestellt'#13+
                      'i <i></i> Schrgschrift     -> <i></i> "Italic"'#13+
                      'f <b></b> Fettschrift       -> <b></b> "Bold"'#13+
                      'u <u></u> Unterstrichen     -> <u></u> "Underline"'#13+
                      '^ <sup></sup> Hochgestellt'#13+
                      ' <sub></sub> Tiefgestellt'#13+

                      '_ _ Link und Bild'#13+
                      'L <a_href=""></a> Link setzten      -><a href="Adresse"></a>'#13+
                      'B <img_src=""_width=""_height=""_alt=""> '+
                         'Bild einfgen     -><img src="Adresse" width="105" height="210" alt="Beispiel">'#13+

                      '_ _ Zeichen, die in HTML reserviert sind'#13+
                      '<  kleiner als (in HTML Sonderfunktion)'#13+
                      '>  grer  als (in HTML Sonderfunktion)'#13+
                      '"  Anfhrungszeichen (in HTML Sonderfunktion)'#13+
                      '&  Kaufmnnisch und  (in HTML Sonderfunktion)'#13+

                      '_ _ Schrift'#13#10+
                      'Y <font_size="+1"></font> grer'#13#10+
                      'y <font_size="-1"></font> kleiner'#13#10+
                      'r <font_color=red></font> rot'#13#10+

                      '_ _ griechische Zeichen und Sonderzeichen'#13+
                      'a  alpha'#13+
                      'b  beta'#13+
                      'g  gamma'#13+
                      'D  Delta'#13+
                      'e  epsilon'#13+
                      'P  Pi'#13+
                      'E  Euro-Zeichen'#13+
                      'T  Trademark'#13+

                      '_ _ mathematische Zeichen'#13+
                      '2  Hoch zwei'#13+
                      '3  Hoch drei'#13+
                      '+  plus minus'#13+
                      '#  ungleich'#13+
                      'x  Malzeichen'#13+
                      '*  Punkt als Malzeichen'#13+
                      'w  quadratwurzel'#13+
                      'K  kleiner gleich'#13+
                      'G  grer gleich'#13+
                      '~  beinahe gleich'#13+
                      'U  unendlich'#13+
                      'S  Summe'#13+
                      'I  Integral'#13+
                      '-  berstrich'#13+

                      '_ _ Sonstiges'#13+
                      '1 <h1_align="center"></h1> berschrift'#13+
                      'p <pre_style="font-size:10pt;line-height:7pt;"></pre>'#13+
                      'Z <div_style="page-break-before:always"></div> Neue Seite';
var
  Form2: TForm2;
  Form2Rueckabe: string;

implementation
uses Unit_ttText_hilf, Unit_ttText_wav;
{$R *.DFM}

function wort_2(const s: string): string;
var k: integer;
begin
  result := wort_(s,2);
  for k := 1 to length(result) do if result[k] = '_' then result[k] := ' ';
end;

function wort_3(s: string): string;
var n: integer;
begin
  n := pos(' ', s);
  s := copyab(s,n+1);
  n := pos(' ', s);
  result := copyab(s,n+1);
end;



procedure TForm2.FormCreate(Sender: TObject);
  var k,j: integer;
      pu: Tstringlist;
begin
  top := 0;
  with stringgrid1 do Begin
    ColWidths[0] := 30;
    ColWidths[1] := 60;
    ColWidths[2] := 110;
    width := 210;
    form2.ClientWidth := 210;
    left := screen.Width - 220;
    cells[ 0,0] := 'Taste';
    cells[ 1,0] := 'HTML';
    cells[ 2,0] := 'Bemerkung';
  End;
  pu := Tstringlist.Create;
  try
    pu.Text := adjustlinebreaks(HTMLZeichen);
    //Nur zu Testzwecken
    for k := 0 to pu.count - 1 do for j := k + 1 to pu.count - 1 do
      if (pu[k][1] <> '_') and (pu[k][1] = pu[j][1] ) then prs(pu[k]+#13+pu[j]);
    for k := 0 to pu.Count - 1  do with stringgrid1 do Begin
      rowcount := k + 2;
      cells[0,k+1] := pu[k][1];
      cells[1,k+1] := wort_2(pu[k]);
      cells[2,k+1] := wort_3(pu[k]);
    End;
    finally pu.free  End;
   Height := stringgrid1.DefaultRowHeight * (stringgrid1.Rowcount+5);
end;

procedure TForm2.StringGrid1KeyPress(Sender: TObject; var Key: Char);
  var k: integer;
begin
   Case key of #8: key := 'h';
               #19: key := 's';
               #16: key :='p';
               #9: key := 'i';
               '_': key := #0; //nur zur Gliederung in der ersten Spalte
   End;
   if key = #27 then Begin
     Form2Rueckabe := #27;
     close;
   End;
   with stringgrid1 do
     for k := 1 to Rowcount do
       if char(key) = cells[0,k] then Begin
         Form2Rueckabe := cells[1,k];
         close;
         exit;
       End;
   tontief;
end;

procedure TForm2.StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
                                     Rect: TRect; State: TGridDrawState);
begin
 with sender as Tstringgrid do
   if (Acol=2) and (pos('_',cells[Acol-2,ARow]) > 0) then Begin
     Canvas.brush.Color := clred;
     Canvas.Font.Color := clwhite;
     canvas.Font.Name := 'Arial';
     canvas.Font.Size := 12;
     canvas.fillRect(Rect);
     canvas.TextOut(Rect.Left,Rect.Top,Cells[ACol,ARow]);
 End;
end;

end.
