unit unit15Rechenblatt;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, StdCtrls, Menus;

type
  TForm15Rechenblatt = class(TForm)
    Panel1: TPanel;
    Memo1: TMemo;
    Splitter1: TSplitter;
    RichEdit1: TRichEdit;
    Label1: TLabel;
    Everlauf: TEdit;
    Label2: TLabel;
    ERechner: TEdit;
    Button4: TButton;
    Label3: TLabel;
    Edazu: TEdit;
    Label4: TLabel;
    Button5: TButton;
    MainMenu1: TMainMenu;
    Bearbeiten1: TMenuItem;
    Sonderzeichen1: TMenuItem;
    Datei1: TMenuItem;
    Berechnungenbernehmen1: TMenuItem;
    Abbrechen1: TMenuItem;
    Beispiel1: TMenuItem;
    Label5: TLabel;
    Beispielausblenden1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ERechnerChange(Sender: TObject);
    procedure RichEdit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EverlaufChange(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Sonderzeichen1Click(Sender: TObject);
    procedure Memo1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Beispielausblenden1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

const ZiffernEtc = [' ', '0'..'9', '.', ',', '+' ,'-', '*', '/', '(', ')', '', ':'];


var
  Form15Rechenblatt: TForm15Rechenblatt;
  Form15Rechenblattuebergabe: string;
  Form15Rechenblattstand: extended;
implementation
  uses unit1, Unit_ttText_hilf, unit_tttext_math;
{$R *.DFM}

procedure TForm15Rechenblatt.FormCreate(Sender: TObject);
  const Anleitung =
'Hinweis: Dieses Fenster knnen Sie "zuziehen":'#13+
'Rechnen: In den Rechner den Rechenaudruck schreiben. Zum Beispiel:'#13+
'         4,1*(51,8-13/4)'#13+
''#13+
'Addieren und Subtrahieren:'#13+
'Zum Beispiel:'#13+
''#13+
'Mitgliedsbeitrge                13 860,00 EUR'#13+
'Handwerker                      - 2 112.70 EUR (Punkt oder Komma)'#13+
'Mieten                           30 120,00 EUR'#13+
''#13+
'       Summe                     41 867,30 EUR'#13+
''#13+
'Berechnung folgendermaen:'#13+
'   Mit Knopf "Lschen" die aufgelaufene Berechnungen auf 0 setzten.'#13+
'   Die Schreibmarke vor "13 860,00 EUR" setzen und dann zwei mal F4-Taste bettigen.'#13+
'   Sie knnen dann den Rechnungungsverlauf verfolgen'#13+
'   und das Ergebnis mit Knopf "Einfgen" in den (rosa) Text bringen.'#13+
''#13+
'Rechenausdrcke sind im Text erlaubt. Zum Beispiel:'#13+
''#13+
'Mitgliedsbeitrge 19870 EUR   =  ??? (noch nicht berechnet)'#13+
'Handwerker                       - 2 112,70 EUR'#13+
'Mieten   12(5250+ 4315) EUR =  ???'#13+
''#13+
'       Summe'#13+
''#13+
'(Das -Malzeichen erhalten Sie im (rosa Arbeitsblatt) mit "Strg+H+*".)'#13+
''#13+
''#13+
'Berechnung hnlich:'#13+
'   Mit Knopf "Lschen" die aufgelaufene Summe auf 0 setzten.'#13+
'   Die Schreibmarke vor  19870 setzen. Das Ergebnis dahinter'#13+
'   einsetzten etc.'#13#13+
'Lsung:'#13#13+
'Mitgliedsbeitrge 19870 EUR   =  13 860,00 EUR'#13+
'Handwerker                       - 2 112,70 EUR'#13+
'Mieten   12(5*250+ 4*315) EUR =  30 120,00 EUR'#13+
'-'#13+
'       Summe                      41 867,30 EUR';

begin
   setbounds(0,0,screen.width, screen.height);
   memo1.Lines.Clear;
   memo1.Text := MitLeerstellenaufgefuellt(adjustlinebreaks(Anleitung));
end;

procedure TForm15Rechenblatt.Button1Click(Sender: TObject);
begin
   memo1.Height := 500;
end;

procedure TForm15Rechenblatt.Button3Click(Sender: TObject);
begin
  if frage('Berechnungen alle verwerfen?') then Begin
    Form15Rechenblattuebergabe := '';
    close;
  End;
end;

procedure TForm15Rechenblatt.Button2Click(Sender: TObject);
begin
   Form15Rechenblattuebergabe := richedit1.text;
   close;
end;

procedure TForm15Rechenblatt.ERechnerChange(Sender: TObject);
begin
  try
    everlauf.Text := formatfloat('### ### ##0.### ### ###',TermToReal(erechner.Text));
  except End;
end;

function TextAbCursor(ed: TCustomEdit): string;
  var i: integer;
begin
  result := '';
  with ed do Begin
    i := SelStart + 1;
    while (i <= length(text)) and (text[i] <> #13) do BEgin
      result := result + text[i];
      inc(i)
    ENd;
  End;
end;

procedure ohneAnfangsTextUndZweiLeerzeichen(var s: string); //und ohne zwei Leerzeichen bis auf z.B.
                                            // '-      4 695' siehe ttted Addtiere
  var i: integer;
begin
  i := 1;
  while (i <= length(s)) and not (s[i] in ZiffernEtc) do inc(i);
  s := copyab(s, i);
  while (length(s) > 1) and (s[1] in ['+', '-']) and (s[2] = ' ') do
    s := s[1] + copyab(s, 3); //z.b. s='-      4 695' -> s='-4 695';
    //Ein Space erlaubt, mehr nicht
  if pos('  ', s) > 0 then s := copy(s, 1, pos('  ', s) - 1);
  //s := ohneLeerzeichenf(s);
end;

procedure setzeCursorIndienaechsteZeile(ed: TCustomEdit);
  var k,pos: integer;
begin
  with ed do Begin
    k:= selstart;
    while (k > 0) and (text[k] <> #13) do dec(k);
    pos := selstart - k;
    k := selstart;
    while (k < length(text)) and (text[k] <> #13) do inc(k);
    selstart := k + pos;
  End;
end;

function ohneEndtext(var s: string): string;
   var k: integer;
begin
  k := 1;
  while (k <= length(s)) and (s[k] in ZiffernEtc) do inc(k);
  s := trim(copy(s,1,k-1));
end;

procedure MitF4BerechnungenDurchfueren(Sender: TObject; key: word);
   //form15Rechenblatt.edazu und ...verlaufwird zur Ausdgabe bentigt
   //Summe wird in globaler Variablen Form15Rechenblattstand gespeichert
  var s: string;
      dazu: extended;
      ed: TCustomEdit;
begin
  ed := sender as TCustomEdit;
  if (key = vk_f4) or (key = vk_f5) then Begin
    s := trim(TextAbCursor(ed));
    ohneAnfangsTextUndZweiLeerzeichen(s);
    OhneEndText(s);
    try
      dazu := TermToReal(s);
      if key = vk_f5 then dazu := - dazu;
      form15Rechenblatt.edazu.Text := formatfloat('### ### ##0.### ### ###',dazu);
    except form15Rechenblatt.edazu.text := 'Fehler'; dazu := 0 End;
    Form15Rechenblattstand := Form15Rechenblattstand + dazu;
    Form15Rechenblatt.everlauf.text := formatfloat('### ### ##0.### ### ###', Form15Rechenblattstand);
    setzeCursorIndienaechsteZeile(ed);
  End;
end;


procedure TForm15Rechenblatt.RichEdit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  MitF4BerechnungenDurchfueren(Sender, key);
end;

procedure TForm15Rechenblatt.EverlaufChange(Sender: TObject);
   var s: string;
begin
  s := everlauf.Text;
  if s = '' then s := '0';
  try
    Form15Rechenblattstand := TermtoReal(s)
  except Form15Rechenblattstand := 0 End;
end;

procedure TForm15Rechenblatt.Button4Click(Sender: TObject);
begin
  edazu.Text := '';
  everlauf.Text := '0';
end;

procedure TForm15Rechenblatt.Button5Click(Sender: TObject);
  var s: string;
begin
  s := formatfloat('### ### ##0.##', Form15Rechenblattstand);
  if pos(Decimalseparator,s) > 0 then
  s := formatfloat('### ### ##0.00', Form15Rechenblattstand); //aus 5,3 wird 5,30
  richedit1.SelText := s;
  richedit1.SetFocus;
end;

procedure TForm15Rechenblatt.Sonderzeichen1Click(Sender: TObject);
begin
 StrgH_Sonderzeichen(Richedit1);
end;

procedure TForm15Rechenblatt.Memo1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   MitF4BerechnungenDurchfueren(Sender, key);
end;

procedure TForm15Rechenblatt.Beispielausblenden1Click(Sender: TObject);
begin
  memo1.height := 1;
end;

end.
