{$I DebuggerAnAus.pas}
unit Unit_ttText_ini;

interface

uses classes, Sysutils;

var  IniInhalt: TStringlist;

procedure schreibeIni(section,schluessel,was:string);
function LeseIni(section,schluessel: string): string;
procedure schreibeIniStringlist(section,schluessel,stringlisttext:string);
function LeseINIStringlist(section,schluessel: string): string;

implementation

uses Unit_ttText_hilf;

function IniPfad:string;
  var exepfad, exefile: string;
begin
 exepfad := extractFilepath(paramstr(0));
 exefile := extractFilename(paramstr(0));
 result:=exepfad                               //der exe-pfad des Programms
         + copy(exefile,1,length(exefile) - 3) //der Name ohne "exe"
         + 'ini';                              //die Ini-Datei
end;

function AnfangDerZeile(section,schluessel: string) :string;
begin
  result := section + '|' + schluessel + ' = ';
end;

procedure schreibeIni(section,schluessel,was:string);
  var k:integer;
begin
  for k := 0 to IniInhalt.Count - 1 do
    if pos(AnfangDerZeile(section,schluessel), IniInhalt[k]) = 1
      then Begin //Eintrag lschen bzw. berschreiben
        if was = '' then iniInhalt.Delete(k) else
          iniInhalt[k] := AnfangDerZeile(section,schluessel) + was;
        exit;
      End;
  //Neueintrag
  if was > '' then  iniInhalt.Add(AnfangDerZeile(section,schluessel) + was);
end;

function LeseIni(section,schluessel: string): string;
  var k:integer;
begin
  for k := 0 to IniInhalt.Count - 1 do
    if pos(AnfangDerZeile(section,schluessel), IniInhalt[k]) = 1
      then Begin
        result := copyab(IniInhalt[k],
           length(AnfangDerZeile(section,schluessel)) + 1);
        exit;
      End;
  result :='';
end;


function intToStr4(k:integer): string; //von 0000 bis 9999 alphabetisch
begin
  result := inttostr(k);
  while length(result) < 4 do result := '0' + result;
end;

procedure loescheStringlistInIni(s:string);
  var k:integer;
begin
  k := 0;
  while k < IniInhalt.Count do Begin
    if pos(s,IniInhalt[k]) = 1 then iniInhalt.Delete(k) else inc(k);
  End;

end;

procedure schreibeIniStringlist(section,schluessel,stringlisttext:string);
  var sl: Tstringlist;
       k: integer;
  function LeseIni(section,schluessel: string): string;
    var k:integer;
  begin
    for k := 0 to IniInhalt.Count - 1 do
      if pos(AnfangDerZeile(section,schluessel), IniInhalt[k]) = 1
        then Begin
          result := copyab(IniInhalt[k],
             length(AnfangDerZeile(section,schluessel)) + 1);
          exit;
        End;
    result :='';
  end;
begin
  loescheStringlistInIni(section + '|' + schluessel + '|');
  sl := Tstringlist.Create;
  sl.Text := stringlisttext;
  try
    for k := 0 to sl.Count - 1 do
      schreibeIni(section,schluessel + '|' + inttostr4(k) + '|', sl[k]);
  finally sl.free End;
end;

function LeseINIStringlist(section,schluessel: string): string;
  var sl: Tstringlist;
       k: integer;
begin
  sl := Tstringlist.Create;
  try
    for k := 0 to IniInhalt.count - 1  do
      if pos(section + '|' + schluessel + '|', IniInhalt[k]) = 1
      then Begin
        sl.add(copyab(IniInhalt[k],length(section + '|' + schluessel + '|') + 9));
      End;
    result := sl.text;
  finally sl.free End;
end;

initialization

  IniInhalt := Tstringlist.create;
  try
    iniInhalt.LoadFromFile(IniPfad);

  except {Das erste Mal} End;

finalization

  try
    iniInhalt.SaveToFile(IniPfad);
  except {Keine Schreibrechte}  End;
  IniInhalt.Free;


end.
